--- /usr/sbin/update-dictcommon-aspell.orig	2008-07-03 19:26:35.000000000 +0200
+++ /usr/sbin/update-dictcommon-aspell	2008-08-23 11:43:34.453341900 +0200
@@ -11,6 +11,7 @@
 updatedb ($class);
 build_emacsen_support ();
 build_jed_support ();
+build_squirrelmail_support ();
 
 system ("aspell-autobuildhash") == 0
     or die "Error running aspell-autobuildhash\n";
--- /usr/share/perl5/Debian/DictionariesCommon.pm.orig	2008-07-03 19:26:35.000000000 +0200
+++ /usr/share/perl5/Debian/DictionariesCommon.pm	2008-08-23 12:19:20.603448553 +0200
@@ -116,25 +116,35 @@
   my $T_option    = "";
   my $ispell_args = "";
 
-  $d_option = "-d $language->{'hash-name'}"
-      if exists $language->{'hash-name'};
-  $w_option = "-w $language->{'additionalchars'}"
-      if exists $language->{'additionalchars'};
+  if ($class eq 'ispell')
+  {
+    $d_option = "-d $language->{'hash-name'}"
+        if exists $language->{'hash-name'};
+    $w_option = "-w $language->{'additionalchars'}"
+        if exists $language->{'additionalchars'};
 
-  if ( exists $language->{'extended-character-mode'} ){
-    $T_option =  $language->{'extended-character-mode'};
-    $T_option =~ s/^~//; # Strip leading ~ from Extended-Character-Mode.
-    $T_option =  '-T ' . $T_option;
-  }
+    if ( exists $language->{'extended-character-mode'} ){
+      $T_option =  $language->{'extended-character-mode'};
+      $T_option =~ s/^~//; # Strip leading ~ from Extended-Character-Mode.
+      $T_option =  '-T ' . $T_option;
+    }
 
-  if ( exists $language->{'ispell-args'} ){
-    $ispell_args = $language->{'ispell-args'};
-    foreach ( split('\s+',$ispell_args) ) {
-      # No d_option if already in $ispell_args
-      $d_option = "" if /^\-d/;
+    if ( exists $language->{'ispell-args'} ){
+      $ispell_args = $language->{'ispell-args'};
+      foreach ( split('\s+',$ispell_args) ) {
+        # No d_option if already in $ispell_args
+        $d_option = "" if /^\-d/;
+      }
     }
+
+    return "$d_option $w_option $T_option $ispell_args";
   }
-  return "$d_option $w_option $T_option $ispell_args";
+  elsif ($class eq 'aspell')
+  {
+    return "-l $language->{'hash-name'}";
+  }
+
+  return '';
 }
 
 # ------------------------------------------------------------------
@@ -438,25 +448,24 @@
 # Build support file for squirrelmail with a list of available
 # dictionaries and associated spellchecker calls, in php format.
 # ------------------------------------------------------------------
-  my $class        = "ispell";
-  my $dictionaries = loaddb ($class);
-  my $php          = "<?php\n";
+  my @classes      = ("aspell","ispell");
   my @dictlist     = ();
 
-  $php .= generate_comment ("### ");
-  $php .= "\$SQSPELL_APP = array (\n";
-  foreach ( keys %$dictionaries ){
-    next if m/.*[^a-z]tex[^a-z]/i;            # Discard tex variants
-    my $spellchecker_params =
-	&dc_get_spellchecker_params($class,$dictionaries->{$_});
-    push @dictlist, qq {  '$_' => 'ispell -a $spellchecker_params'};
+  foreach my $class (@classes)
+  {
+    my $dictionaries = loaddb ($class);
+  	print STDERR "Loading class $class = %{$dictionaries}\n";
+    foreach ( keys %$dictionaries ){
+      next if m/.*[^a-z]tex[^a-z]/i;            # Discard tex variants
+      my $spellchecker_params = &dc_get_spellchecker_params($class,$dictionaries->{$_});
+	  next if ! /^(\S+)\s+\((.+)\)$/;
+      push @dictlist, qq { '$2 ($class)' => '$class -a $spellchecker_params' };
+    }
   }
-  $php .= join(",\n", @dictlist);
-  $php .= "\n);\n";
 
   open (PHP, "> $cachedir/$squirrelmailsupport")
       or die "Cannot open SquirrelMail cache file";
-  print PHP $php;
+  print PHP "<?php\n" . generate_comment ("### ") . "\$SQSPELL_APP = array (\n" . join(",\n", @dictlist) . "\n);\n?>\n";
   close PHP;
 }
 
